<?php
namespace FM\Service;

use FM\Factory\RelatoriosTarefasFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\FuncionariosHierarqService;

class RelatoriosTarefasService {

    protected $RelatoriosTarefasFactory;
    protected $FuncionariosHierarqService;
    protected $Environment;
    protected $newCode;

    public function __construct (RelatoriosTarefasFactory $RelatoriosTarefasFactory, FuncionariosHierarqService $FuncionariosHierarqService, Environment $Environment, NewCode $newCode) {
        $this->RelatoriosTarefasFactory     = $RelatoriosTarefasFactory;
        $this->FuncionariosHierarqService   = $FuncionariosHierarqService;
        $this->Environment                  = $Environment;
        $this->newCode                      = $newCode;
    }

    public function getRelatoriosTarefas() {
        
        $cdoperador = $this->Environment->getCdOperador();
        $listaOperadores = $this->FuncionariosHierarqService->montarHierarquiaOperadores($cdoperador);

        $params = array (
            "CDOPERADOR" => $cdoperador
        );

        return $this->RelatoriosTarefasFactory->getRelatoriosTarefas($params, $listaOperadores);
    }

    public function getItensTarefas($parametros) {
        return $this->RelatoriosTarefasFactory->getItensTarefas($parametros['NRCHECKLISTAGEND']);
    }

    public function getFotosTarefas($parametros) {
        return $this->RelatoriosTarefasFactory->getFotosTarefas($parametros['NRCHECKLISTAGEND']);
    }

    public function getFiltroRelatorioTarefa() {
        return $this->RelatoriosTarefasFactory->getFiltroRelatorioTarefa();
    }

    public function getFiltroRelatorioLocal() {
        return $this->RelatoriosTarefasFactory->getFiltroRelatorioLocal();
    }

    public function getFiltroRelatorioChecklist() {
        return $this->RelatoriosTarefasFactory->getFiltroRelatorioChecklist();
    }

    public function getFiltroRelatorioCliente() {
        return $this->RelatoriosTarefasFactory->getFiltroRelatorioCliente();
    }
}