/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TBVE                                                     */
/* Tabela : TABEVEND                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 03/10/2005  Blenet Ferreira Simes                                        */
/*                                                                            */
/******************************************************************************/


CREATE OR REPLACE TRIGGER DTULTATU_TBVE
BEFORE INSERT OR UPDATE OR DELETE
ON TABEVEND FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUTBVE := SYSDATE;
   END IF;
   IF UPDATING THEN
      :NEW.DTULTATUTBVE := SYSDATE;

      UPDATE ITEMPRECO SET DTULTATUITPR = SYSDATE
      WHERE CDFILIAL    = :OLD.CDFILIAL
        AND CDTABEPREC  = :OLD.CDTABEPREC
        AND DTINIVGPREC = :OLD.DTINIVGPREC;

   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('TABEVEND', :OLD.CDFILIAL, 'CDFILIAL='||:OLD.CDFILIAL||';CDTABEPREC='||:OLD.CDTABEPREC||';DTINIVGPREC='||TO_CHAR(:OLD.DTINIVGPREC,'YYYY-MM-DD HH24:MI:SS')||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE TABEVEND MODIFY DTULTATUTBVE DEFAULT SYSDATE
/

UPDATE TABEVEND SET DTULTATUTBVE = SYSDATE WHERE DTULTATUTBVE IS NULL
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_TBVE','5.07.005'); END;
/

