/* eslint-disable */
import {
  Http, IDictionary, Metadata,
} from '@zeedhi/core';
import { 
  Modal, ModalService, Select,
  TextInput,
} from '@zeedhi/common';

export class ModalTarefasSolicitacoesController {
  private classifyModal!: Modal;

  private insertTypeModal!: Modal;

  /* -------- Criar Modais -------- */

  public async createClassifyModal() {
    this.classifyModal = await ModalService.createFromJson('/modal/modalTarefasClassificarSolicitacao', true);
  }

  /* -------- Destruir Modais -------- */

  public destroyClassifyModal() {
    this.classifyModal.destroy();
  }

  /* -------- Abrir Modais -------- */

  public openClassifyModal() {
    this.classifyModal.show();
  }

  public async openInsertTypeModal() {
    this.insertTypeModal = await ModalService.createFromJson('/modal/modalTarefasTipoSolicitacao', true);
    this.insertTypeModal.show();
  }

  /* -------- Fechar Modais -------- */

  public closeClassifyModal() {
    this.classifyModal.hide();
  }

  public closeInsertTypeModal() {
    this.insertTypeModal.hide();
    this.insertTypeModal.destroy();
  }
  
  /* ---------------modal : Classificar Solicitação --------------- */
  
  public initializeData() {
    this.getRequestTypes();
  }
  
  
  // Busca os tipos de requisição e monta o select
  public getRequestTypes() {
    const selectObject = Metadata.getInstance<Select>('classifyType');
    Http.get('/getRequestTypes').then((response: IDictionary) => {
      response.data.dataset.info.forEach((database: IDictionary) => {
        selectObject.datasource.data.push({
          value: database.NRTIPOSOLICITACAO,
          name: database.NMTIPOSOLICITACAO,
          priority: database.IDPRIORIDADEPADR,
        });
      });
    });
  }
}
